CREATE TABLE `reports` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `file_name` varchar(70) NOT NULL,
  `descr` varchar(250) DEFAULT NULL,
  `with_params` tinyint(1) DEFAULT NULL,
  `report` mediumblob NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;

CREATE TABLE `report_params` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `name` varchar(50) NOT NULL,
  `varName` varchar(50) NOT NULL,
  `regex` varchar(50) DEFAULT NULL,
  `regexMes` varchar(250) DEFAULT NULL,
  `valueExpr` varchar(250) DEFAULT NULL,
  `wrapValues` tinyint(1) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;

CREATE TABLE `reports_params` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `reportId` int(10) NOT NULL,
  `paramId` int(10) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;

CREATE TABLE `text_mark` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8;

DELIMITER //
CREATE FUNCTION `GetTextMark`(isAfterExam char(1), examType varchar(20), rate INT) RETURNS varchar(100) CHARSET utf8
    NO SQL
BEGIN
	declare markTextId int;
    declare markText varchar(100) charset utf8;
    if examType = 'credit' then
        if rate < 60 then
			set markTextId = 6;#незачет
		else 
			set markTextId = 7;#зачет
		end if;
    elseif examType = 'gradingcredit' then
		if rate >= 85 then 
			set markTextId = 5;#неуд.
		elseif rate >= 70 then 
			set markTextId = 4;#хорошо
		elseif rate >= 60 then
			set markTextId = 3;#удовл.
		else
			set markTextId = 2;#неуд.
		end if;
    elseif isAfterExam = '0' then
		if rate < 38 then
			set markTextId = 1;#недопуск
		else
			return "";
		end if;
	else
		if rate >= 85 then 
			set markTextId = 5;#неуд.
		elseif rate >= 70 then 
			set markTextId = 4;#хорошо
		elseif rate >= 60 then
			set markTextId = 3;#удовл.
		else
			set markTextId = 2;#неуд.
		end if;
	end if;
    select name from text_mark where id = markTextId into markText;
    return markText;
END//
DELIMITER ;

